{******************************************************************************}
{   Unit/Unit CheckGroupBox                                                   }
{                                                                              }
{   Sorry for my very bad english :-)                                          }
{                                                                              }
{ TCheckGroupBox :                                                             }
{   TGroupBox qui intgre une TCheckBox et qui permet d'activer ou de          }
{   dsactiver les contrles enfants du GroupBox.                              }
{   TGroupBox which integrates TCheckBox and which makes it possible to        }
{   enable or disable child controls of the GroupBox.                          }
{                                                                              }
{   Proprits/Properties :                                                    }
{     - Caption: string                                                        }
{         Caption du checkbox.                                                 }
{         CheckBox Caption.                                                    }
{     - BoxAlignment: TLeftRight                                               }
{         Identique  la proprit Alignment d'un TCheckBox                    }
{         identical to the Alignment property of TCheckBox                     }
{     - Checked: boolean                                                       }
{         Proprit Checked du TCheckBox.                                      }
{         Checked property of TCheckBox.                                       }
{     - CheckBox: TXCheckBox (Public property)                                 }
{         Disponible uniquement  l'excution pour accder  d'autres          }
{         proprits de la CheckBox ou programmer d'autres vnements, voir    }
{         la dclaration de TXCheckBox ci-dessous pour la liste des proprits }
{         publies.                                                            }
{         Available only at runtime to reach others properties of CheckBox or  }
{         to program other events, see below the TXCheckBox declaration for    }
{         the list of published properties.                                    }
{   Evenements/Events :                                                        }
{     - OnCheckBoxClick: TNotifyEvent                                          }
{         Se produit aprs avoir cliqu sur la CheckBox et aprs que les       }
{         contrles soit activs ou dsactivs.                                }
{         Occurs after having clicked on CheckBox and after the controls is    }
{         enabled or desabled.                                                 }
{                                                                              }
{                                                                              }
{  COPYRIGHT / GARANTIE                                                        }
{                                                                              }
{ Ce composant est un gratuiciel et donc libre de droits. Il est fourni        }
{ TEL QUEL, sans aucune garantie expresse ou tacite, pour quelque raison       }
{ que ce soit, y compris d'ventuels dommages causs par l'utilisation de ce   }
{ composant, les dommages pour pertes de profits, cessation d'activites        }
{ commerciales ou autre.                                                       }
{ Vous pouvez utiliser ce composant comme bon vous semble, except pour une    }
{ utilisation commerciale, c'est  dire ne pas utiliser tout ou  partie de ce  }
{ composants dans un projet commercial (Dans ce cas le paiement d'une modeste  }
{ licence vous sera demand - contactez moi pour les prcisions).              }
{ Vous ne pouvez pas prtendre avoir crit ces composants et vous n'tes pas   }
{ autoris  supprimer l'en-tte du fichier source (question d'thique).       }
{ Si vous n'tes pas en accord avec ce qui prcde, ne l'utilisez pas.         }
{                                                                              }
{ Donc, si vous modifiez ou amliorez ce composant, laissez intacte l'en-tte  }
{ de ce fichier et ajoutez vos commentaires  la fin de cet l'en-tte.         }
{ Tous commentaires et/ou suggestions, rapport de bug, seront apprcis.       }
{ Si vous l'utilisez dans un projet, merci de mentionner mon nom et mon        }
{ adresse E-Mail.                                                              }
{                                                                              }
{  COPYRIGHT/ LIMITED WARRANTY                                                 }
{                                                                              }
{  THIS COMPONENT IS FREEWARE AND PROVIDED 'AS IS' WITHOUT WARRANTIES OF ANY   }
{  KIND, EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED }
{  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.         }
{  THE AUTHOR DOESN'T ASSUME ANY RESPONSIBILITY FOR ANY DAMAGE OR ANY LOOSE OF }
{  TIME OR MONEY DUE THE USE OF ANY PART OF THIS COMPONENT. THE AUTHOR SHALL   }
{  NOT BE LIABLE FOR INCIDENTAL, CONSEQUENTIAL, LOSS OF BUSINESS PROFITS OR    }
{  SPECIAL OR INDIRECT DAMAGES OF ANY SORT, WHETHER ARISING IN TORT, CONTRACT  }
{  OR OTHERWISE, EVEN IF THE AUTHOR HAS BEEN INFORMED OF THE POSSIBILITY OF    }
{  SUCH DAMAGES.                                                               }
{                                                                              }
{  THE AUTHOR ARE SURE YOU KNOW THAT A NULL-COST FREE SOFTWARE DOES NOT        }
{  PROVIDE ANY WARRANTIES.                                                     }
{  IF YOU DON'T AGREE THIS TERMS, DON'T USE THIS COMPONENT.                    }
{                                                                              }
{  You can use this component as you want, EXCEPT FOR A COMMERCIAL USE (what   }
{  obliges the payment of a weak licence).                                     }
{  You cannot claim to have written these components and you are NOT authorized}
{  to remove the heading of source file (ethics problem).                      }
{                                                                              }
{  If you modify the source or make corrections or additions, add simply your  }
{  comments, a description and your name at the end of heading. In that case   }
{  thank you to send me a copy of your modifications.                          }
{                                                                              }
{  You can send me an e-mail with a bugs list, a request for modification or   }
{  development of new functionalities.                                         }
{  Generally, all comments or suggestions will be appreciated. Please, tell me }
{  what you do with this component, or simply Hello, I like your component.    }
{  If you use it in a project, thank's to mention my name and my               }
{  E-Mail addresses.                                                           }
{                                                                              }
{ Auteur/Author : Jean-Michel BOUCTON                                          }
{ email : jmbo@softhome.net                                                    }
{ See other components at http://www.chez.com/jmbo/index.html                  }
{                                                                              }
{------------------------------------------------------------------------------}
{ Auteur/Author : Jean-Michel BOUCTON                                          }
{ Version : 1.0.0                                                              }
{ Cration/Creation : 27/04/1999                                               }
{                                                                              }
{ Cration de TCheckGroupBox, (dvelopp pour Renbatch V2.0)                   }
{ Creation of TCheckGroupBox, (developed for Renbatch V2.0)                    }
{------------------------------------------------------------------------------}
{ Auteur/Author : Jean-Michel BOUCTON                                          }
{ Version : 1.1.0                                                              }
{ Date : 04/05/1999                                                            }
{                                                                              }
{ Changements mineurs.                                                         }
{ Some minor changes.                                                          }
{------------------------------------------------------------------------------}
{ Auteur/Author : Jean-Michel BOUCTON                                          }
{ Version : 1.2.0                                                              }
{ Date : 16/06/1999                                                            }
{                                                                              }
{ - Modifications pour que les contrles enfants soit griss quand la case    }
{   cocher est dsactive ou quand la CheckGroupBox elle-mme est dsactive,  }
{   ( la demande de john Knipper).                                            }
{ - Modifications so that child controls is grayed when the checkbox is        }
{   disabled or when CheckGroupBox itself is disabled,                         }
{   (at the request of John Knipper).                                          }
{------------------------------------------------------------------------------}
{ Auteur/Author :                                                              }
{ Version :                                                                    }
{ Date :                                                                       }
{                                                                              }
{******************************************************************************}
unit CheckGroupBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TXCheckBox = class(TCustomCheckBox)
  published
    property AllowGrayed;
    property Color;
    property Ctl3D;
    property Enabled;
    property ShowHint;
    property State;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;

  TCheckCustomGroupBox = class(TCustomGroupBox)
  private
    FCheckBox: TXCheckBox;
    FChecked: boolean;
    FOnCheckBoxClick: TNotifyEvent;
    function GetAlignment: TLeftRight;
    procedure SetAlignment(Value: TLeftRight);
    function GetCaption: TCaption;
    procedure SetCaption(Value: TCaption);
    procedure AdjustCheckBounds;
    procedure SetChecked(Value: boolean);
    procedure WMENABLE(var Message: TWMEnable); message WM_ENABLE;
  protected
    procedure CheckBoxClick(Sender: TObject); virtual;
    procedure EnableControls(WControl: TWinControl; var Message: TWMEnable{Comp: TComponent; Enable: boolean}); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property CheckBox: TXCheckBox read FCheckBox write FCheckBox;
  published
    property BoxAlignment: TLeftRight read GetAlignment write SetAlignment;
    property Caption: TCaption read GetCaption write SetCaption;
    property Checked: boolean read FChecked write SetChecked;
    property OnCheckBoxClick: TNotifyEvent read FOnCheckBoxClick write FOnCheckBoxClick;
  end;

  TCheckGroupBox = class(TCheckCustomGroupBox)
  published
    property Align;
    property Caption;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

const
  BoxWith = 19;

implementation

constructor TCheckCustomGroupBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  inherited Text := '-';
  FCheckBox := TXCheckBox.Create(Self);
  FChecked := true;
  with FCheckBox do
  begin
    TCheckBox.Create(Self);
    Parent := Self;
    OnClick := CheckBoxClick;
    Checked := true;
    Left := 6;
    Width := 18;
    inherited Top := 0;
    Caption := '';
  end;
end;

destructor TCheckCustomGroupBox.Destroy;
begin
  FCheckBox.Free;
  inherited Destroy;
end;

procedure TCheckCustomGroupBox.WMENABLE(var Message: TWMEnable);
begin
  EnableControls(Self, Message);
end;

function TCheckCustomGroupBox.GetAlignment: TLeftRight;
begin
  Result := FCheckBox.Alignment;
end;

procedure TCheckCustomGroupBox.SetAlignment(Value: TLeftRight);
begin
  FCheckBox.Alignment := Value;
end;

function TCheckCustomGroupBox.GetCaption: TCaption;
begin
  Result := FCheckBox.Caption;
end;

procedure TCheckCustomGroupBox.SetCaption(Value: TCaption);
begin
  if (FCheckBox.Left + Canvas.TextWidth(Value) + BoxWith) < Width then
  begin
    FCheckBox.Caption := Value;
    AdjustCheckBounds;
  end;
end;

procedure TCheckCustomGroupBox.AdjustCheckBounds;
const
  WordWraps: array[Boolean] of Word = (0, DT_WORDBREAK);
begin
  // Par dfaut La Font du checkbox est celle de son parent
  FCheckBox.Width := BoxWith + Canvas.TextWidth(FCheckBox.Caption) + 2;
  FCheckBox.Repaint;
end;

procedure TCheckCustomGroupBox.SetChecked(Value: boolean);
begin
  FCheckBox.Checked := Value;
  CheckBoxClick(nil);
end;

procedure TCheckCustomGroupBox.CheckBoxClick(Sender: TObject);
var
  i: integer;
begin
  inherited Click;
  FChecked := FCheckBox.Checked;
  for i := 0 to ControlCount - 1 do
  begin
    if Controls[i] is TXCheckBox then
      continue;
    Controls[i].Enabled := FChecked;
  end;
  if Assigned(FOnCheckBoxClick) then FOnCheckBoxClick(Self);
end;

procedure TCheckCustomGroupBox.EnableControls(WControl: TWinControl; var Message: TWMEnable{Comp: TComponent; Enable: boolean});
var
  i: integer;
begin
  if not (csDesigning in ComponentState) then
    if WControl.controlcount > 0 then
    begin
      if (WControl = Self) then
        if (not Self.Enabled) and (not FChecked) and  (not Message.Enabled) then
          Self.FCheckBox.Enabled := false  // Pour griser aussi la chexbox
        else                               // quand le contrle est dsactiv
          Self.FCheckBox.Enabled := true;
      for i := 0 to WControl.ControlCount - 1 do
        if (WControl.Controls[i] is TWinControl) and FChecked then
            EnableControls(TWinControl(WControl.Controls[i]), Message);
    end else
      if WControl.HandleAllocated then
        if (WControl.Parent is TCheckCustomGroupBox) and
          not (WControl.Parent as TCheckCustomGroupBox).Checked then
        begin
          if (WControl is TXCheckbox) and WControl.Parent.Enabled then
            EnableWindow(WControl.Handle, Message.Enabled);
        end else
          EnableWindow(WControl.Handle, Message.Enabled);
end;

end.
